import subprocess
import loadOptimizeDockOptions
import time
import os

def prep(configFilePath):
	loadOptimizeDockOptions.load(configFilePath)
	ODO = loadOptimizeDockOptions.load.optimizeDockOptions
	cwd = os.getcwd()
	os.chdir(ODO['sandboxPath'])
	
	#First, write the DMS file.
	print 'running dms'
	runDMSCommand = '%s/dms rec_noH_%s.pdb -n -w 1.4 -o rec_%s.dms' \
	%(ODO['dmsPath'],\
	ODO['pdbCode'],\
	ODO['pdbCode'])
	runDMS = subprocess.Popen(runDMSCommand,shell=True)
	runDMS.wait()

	#Write the INSPH file needed to generate spheres.
	print 'making insph'
	insphData = ['rec_%s.dms\n' %(ODO['pdbCode']),\
	'R\n',\
	'X\n',\
	'0.0\n',\
	'4.0\n',\
	'1.4\n',\
	'rec_%s.sph\n' %(ODO['pdbCode'])]
	insphFile = open('INSPH','w')
	insphFile.writelines(insphData)
	insphFile.close()

	#Now generate the spheres.
	print 'running sphgen'
	runSphGenCommand = '%s/sphgen' %(ODO['dockBinaryPath'])
	runSphGen = subprocess.Popen(runSphGenCommand,shell=True)
	runSphGen.wait()
	

	#Select the spheres within a radius of the ligand.
	print 'running sphere_selector'
	runSphereSelectorCommand = \
	'%s/sphere_selector rec_%s.sph lig_charged_%s.mol2 10.0'\
	%(ODO['dockBinaryPath'],\
	ODO['pdbCode'],\
	ODO['pdbCode'])
	runSphereSelector = subprocess.Popen(runSphereSelectorCommand,shell=True)
	runSphereSelector.wait()

	#Create the box.in input file.
	print 'making box.in'
	boxData = ['Y\n', \
	'5\n', \
	'%s/selected_spheres.sph\n' %(ODO['sandboxPath']), \
	'1\n', \
	'rec_box_%s.pdb\n' %ODO['pdbCode']]
	boxFile = open('box.in','w')
	boxFile.writelines(boxData)
	boxFile.close()

	#Run showbox.
	print 'running showbox'
	runShowBoxCommand = '%s/showbox < box.in' %(ODO['dockBinaryPath'])
	runShowBox = subprocess.Popen(runShowBoxCommand,shell=True)
	runShowBox.wait()

	#Make grid.in input file.
	print 'making grid.in'
	gridInData = dict()
	gridInData['compute_grids'] = 'yes'
	gridInData['grid_spacing'] = '0.3'
	gridInData['output_molecule'] = 'no'
	gridInData['contact_score'] = 'no'
	gridInData['energy_score'] = 'yes'
	gridInData['energy_cutoff_distance'] = '9999'
	gridInData['atom_model'] = 'a'
	gridInData['attractive_exponent'] = '6'
	gridInData['repulsive_exponent'] = '12'
	gridInData['distance_dielectric'] = 'yes'
	gridInData['dielectric_factor'] = '4'
	gridInData['bump_filter'] = 'yes'
	gridInData['bump_overlap'] = '0.75'
	gridInData['receptor_file'] = '%s/rec_charged_%s.mol2' %(ODO['sandboxPath'],ODO['pdbCode'])
	gridInData['box_file'] = '%s/rec_box_%s.pdb' %(ODO['sandboxPath'],ODO['pdbCode'])
	gridInData['vdw_definition_file'] = ODO['vdw_AMBER_parm99Path']
	gridInData['score_grid_prefix'] = 'grid%s' %(ODO['pdbCode'])
	gridParameters = []
	for key in gridInData:
		gridParameters.append(key + ' ' + gridInData[key] + '\n')
	gridInDataFile = open('grid.in','w')
	gridInDataFile.writelines(gridParameters)
	gridInDataFile.close()

	#Make the energy grids with the "grid" program.
	print 'making energy grids'
	runGridCommand = '%s/grid -i grid.in' %(ODO['dockBinaryPath'])
	runGrid = subprocess.Popen(runGridCommand,shell=True)
	runGrid.wait()
	
	os.chdir(cwd)
