from runFlexibleDock import runFlexibleDock
from sampleNewAnchorAndGrow import sampleNewAnchorAndGrow
import subprocess
import loadOptimizeDockOptions
import time
import os
import pickle

def optimizeDockParameters(configFilePath,numTrials):
	loadOptimizeDockOptions.load(configFilePath)
	ODO = loadOptimizeDockOptions.load.optimizeDockOptions
	cwd = os.getcwd()
	os.chdir(ODO['sandboxPath'])
	bestEnergy = 100.
	errorEncountered = False
	runTimes = dict()
	print 'starting main parameter optimization'
	for i in range(numTrials):
		startTime = time.time()
		print 'sampling new parameter file'
		sampleNewAnchorAndGrow(ODO)
		print 'running flexible docking for iteration %s' %(i)
		runFlexibleDock(ODO)
		print 'reading energy from output file'
		outputName = 'dock%s.out' %(ODO['pdbCode'])
		dockDataFile = open('%s/%s' %(ODO['sandboxPath'],outputName),'r')
		dockData = dockDataFile.readlines()
		dockDataFile.close()
		for line in dockData:
			if line[1:6] == 'ERROR':
				errorEncountered = True
				print 'dock error encountered on iteration %s' %(i)
				break
			elif line[4:14] == 'Grid Score':
					sampledEnergy = float(line[24:35])
		
		#If the DOCK calculation errored out, just proceed to the next sample.
		if errorEncountered == True:
			errorEncountered = False
			continue
		
		#See if the new energy is better. Save its output file to the "best" folder.
		if sampledEnergy < bestEnergy:
			bestEnergy = sampledEnergy
			os.system('mv %s/anchor_and_grow%s.in %s/anchor_and_grow%s.in' \
			%(ODO['sandboxPath'],\
			ODO['pdbCode'],\
			ODO['bestStoragePath'],\
			ODO['pdbCode']))
			
			os.system('mv %s/dock%s.out %s/dock%s.out'\
			%(ODO['sandboxPath'],\
			ODO['pdbCode'],\
			ODO['bestStoragePath'],\
			ODO['pdbCode']))
		runTimes[str(i)] = time.time() - startTime
	pickle.dump(runTimes, open('runTimes.p', 'wb'))
	os.chdir(cwd)
