import random

def sampleNewAnchorAndGrow(optimizeDockOptions):
#Writes anchor_and_grow.in for running flexible docking with DOCK6.
#ANGparameters is a list, containing all of the possible parameters in the
#anchor and grow (ANG) algorithm.
	ODO = optimizeDockOptions
	#Samples a new anchor_and_grow.in file.
	ANGDict = dict()

	#Defaults
	ANGDict['flexible_ligand'] = 'yes'
	ANGDict['user_specified_anchor'] = 'no'
	ANGDict['limit_max_ligands'] = 'no'
	ANGDict['limit_max_anchors'] = 'no'
	ANGDict['skip_molecule'] = 'no'
	ANGDict['read_mol_solvation'] = 'no'
	ANGDict['calculate_rmsd'] = 'yes'
	ANGDict['use_rmsd_reference_mol'] = 'no'
	ANGDict['use_database_filter'] = 'no'
	ANGDict['orient_ligand'] = 'yes'
	ANGDict['automated_matching'] = 'yes'
	ANGDict['critical_points'] = 'no'
	ANGDict['chemical_matching'] = 'no'
	ANGDict['use_ligand_spheres'] = 'no'
	ANGDict['use_internal_energy'] = 'yes'
	ANGDict['internal_energy_rep_exp'] = '12'
	ANGDict['use_clash_overlap'] = 'no'
	ANGDict['write_growth_tree'] = 'no'
	ANGDict['bump_filter'] = 'no'
	ANGDict['score_molecules'] = 'yes'
	ANGDict['contact_score_primary'] = 'no'
	ANGDict['contact_score_secondary'] = 'no'
	ANGDict['grid_score_primary'] = 'yes'
	ANGDict['grid_score_secondary'] = 'no'                                          
	ANGDict['grid_score_rep_rad_scale'] = '1'
	ANGDict['grid_score_vdw_scale'] = '1'                                                
	ANGDict['grid_score_es_scale'] = '1'
	ANGDict['dock3.5_score_secondary'] = 'no'
	ANGDict['continuous_score_secondary'] = 'no'
	ANGDict['descriptor_score_secondary'] = 'no'
	ANGDict['gbsa_zou_score_secondary'] = 'no'                                          
	ANGDict['gbsa_hawkins_score_secondary'] = 'no'
	ANGDict['amber_score_secondary'] = 'no'
	ANGDict['minimize_ligand'] = 'yes'
	ANGDict['minimize_anchor'] = 'yes'
	ANGDict['minimize_flexible_growth'] = 'yes'
	ANGDict['use_advanced_simplex_parameters'] = 'no'
	ANGDict['simplex_random_seed'] = '0'
	ANGDict['atom_model'] = 'all'
	ANGDict['write_orientations'] = 'no'
	ANGDict['num_scored_conformers'] = '1'
	ANGDict['rank_ligands'] = 'no'
	ANGDict['simplex_restraint_min'] = 'no'
	#Files
	ANGDict['receptor_site_file'] = '%s/selected_spheres.sph' %(ODO['sandboxPath'])
	ANGDict['ligand_atom_file'] = '%s/lig_charged_%s.mol2' %(ODO['sandboxPath'],ODO['pdbCode'])
	ANGDict['vdw_defn_file'] = ODO['vdw_AMBER_parm99Path']
	ANGDict['flex_defn_file'] = ODO['flex_defnPath']
	ANGDict['flex_drive_file'] = ODO['flex_drive_tblPath']              
	ANGDict['ligand_outfile_prefix'] = 'anchor_and_grow%s' %(ODO['pdbCode'])
	ANGDict['grid_score_grid_prefix'] = '%s/grid%s' %(ODO['sandboxPath'],ODO['pdbCode'])

	#SAMPLED VARIABLES

	ANGDict['max_orientations'] = str(random.choice(range(100,1100,100)))
	ANGDict['min_anchor_size'] = '2'
	ANGDict['pruning_use_clustering'] = random.choice(['yes','no'])
	ANGDict['pruning_max_orients'] = str(random.choice(range(100,1100,100)))
	#if pruning_use_clustering == yes
	ANGDict['pruning_clustering_cutoff'] = str(random.choice(range(100,1100,100)))
	#if pruning_use_clustering == no
	ANGDict['pruning_orient_score_cutoff'] = str(random.choice(range(100,1100,100)))
	ANGDict['pruning_max_conformers'] = str(random.choice(range(10,110,10)))
	ANGDict['pruning_conformer_score_cutoff'] = str(random.choice(range(10,110,10)))
	#Simplex variables
	ANGDict['simplex_anchor_max_iterations '] = str(random.choice(range(100,1100,100)))
	ANGDict['simplex_max_cycles'] = str(random.choice(range(1,11,1)))
	ANGDict['simplex_score_converge'] = '0.1'                                          
	ANGDict['simplex_cycle_converge'] = '1.0'
	ANGDict['simplex_trans_step'] = '1.0'                                                
	ANGDict['simplex_rot_step'] = '0.1'
	ANGDict['simplex_tors_step'] = str(random.choice(range(1,11,1)))                                              
	ANGDict['simplex_grow_max_iterations'] = str(random.choice(range(100,1100,100)))                                        
	ANGDict['simplex_grow_tors_premin_iterations'] = '0'

	ANGParameters = []
	for key in ANGDict:
		ANGParameters.append(key + ' ' + ANGDict[key] + '\n')

	ANGFile = open('%s/anchor_and_grow%s.in' %(ODO['sandboxPath'],ODO['pdbCode']),'w')
	ANGFile.writelines(ANGParameters)
	ANGFile.close()
