import numpy

class Rotamer:
	def __init__(self,AAName,phi,psi,cutoff):
		self.AAName = AAName
		self.LibFileName = AAName.lower() + '.bbdep.rotamers.lib'
		self.LibraryPath = '/home/abhay/Desktop/workspace/rotamer/Dunbrack/ExtendedOpt1-5/'
		self.FilePath = self.LibraryPath + self.LibFileName
		self.Data = None
		stillReading = True
		hasEncounteredPhiPsi = False
		self.LibFileObj = open(self.FilePath,'r')
		Data = []
		while stillReading:
			line = self.LibFileObj.readline()
			if not line:
				stillReading = False
			else:
				if line[0] == '#':
					continue
				else:
					phiLib = int(line[5:9])
					psiLib = int(line[10:14])
					probabilityLib = float(line[37:45])
					if (phiLib == phi) and (psiLib == psi):
						if hasEncounteredPhiPsi == False:
							hasEncounteredPhiPsi = True
						if probabilityLib > cutoff:
							Data.append(line)
						else:
							stillReading = False
					elif hasEncounteredPhiPsi == True:
						stillReading = False
		self.LibFileObj.close()
		self.Data = Data
		self.phi = phi
		self.psi = psi
	def sample(self):
		u = numpy.random.rand()
		#Compare probabilities.
		cumProb = 0.
		for line in self.Data:
			currentProb = float(line[38:45])
			cumProb += currentProb
			if cumProb > u:
				break
		#Input all data from the sampled line.
		ChiAngleStates = list(str.join('',line[25:35].split()))
		X1 = float(line[45:53]) ;X2 = float(line[53:61])
		X3 = float(line[61:69]) ;X4 = float(line[69:77])
		S1 = float(line[78:87]) ;S2 = float(line[87:95])
		S3 = float(line[95:103]) ;S4 = float(line[103:111])
		sampledState = dict()
		sampledState['ChiAngleStates'] = ChiAngleStates
		sampledState['ChiAngles'] = [X1, X2, X3, X4]
		sampledState['ChiSigmas'] = [S1, S2, S3, S4]
		self.sampledState = sampledState
	#Randomly choose new chi angles, drawn from normal distributions with mean
	#X_i and standard deviation S_i.
	def wiggle(self):
		sampledState = self.sampledState
		ChiAngles = sampledState['ChiAngles']
		ChiSigmas = sampledState['ChiSigmas']
		wiggledState = []
		for i in range(4):
			s = numpy.random.randn()
			wiggledState.append(ChiAngles[i] + s*ChiSigmas[i])
		return wiggledState
